function [y,t,x]=dgpselect(dgp,dgp_cat,c,n)

%###################################################################
%######################### Size DGPS ##############################
%###################################################################

if strcmp(dgp_cat,'Size')==1
    
    
    if (dgp==1)
        X=mvnrnd([0,0,0],[0.25,0,0;0,0.25,0;0,0,2],n); %RUNNING VARIABLE and ERROR TERMs
        u0=X(:,1);
        u1=X(:,2);
        x=X(:,3);
        V=randn(n,1)*sqrt(0.25);
        y1=u1;
        y0=-3+y1-u0;
        t=(V>=0);
        y=y1.*t+y0.*(1-t);
        
    elseif (dgp==2)
        x=norminv(normcdf(-2)+rand(n,1)*(normcdf(2)-normcdf(-2)),0,1);
        u=rand(n,1);
        y1=randn(n,1)+1;
        y0=randn(n,1);
        t=(u>0.5);
        y=y1.*t+y0.*(1-t);
        
    elseif (dgp==3)
        x=norminv(normcdf(-2)+rand(n,1)*(normcdf(2)-normcdf(-2)),0,1);
        u=rand(n,1);
        y1=randn(n,1)+1;
        y0=randn(n,1);
        v=(x<0).*((x+2).^2)/8+(x>=0).*(1-((x-2).^2)/8);
        t=(v>u);
        y=y1.*t+y0.*(1-t);
        
    elseif (dgp==4)
        X=mvnrnd([0,0,0],[0.25,0,0.5;0,0.25,0.5;0.5,0.5,2],n); %RUNNING VARIABLE and ERROR TERMs
        u0=X(:,1);
        u1=X(:,2);
        x=X(:,3);
        V=randn(n,1)*sqrt(0.25);
        y1=u1;
        y0=u0-2;
        t=(x+(x>=0)+V>=0);
        y=y1.*t+y0.*(1-t);
        
    end
end

%###################################################################
%#################### Power Designs #########################
%###################################################################


if strcmp(dgp_cat,'Power')==1
    
    if (dgp==1)
        X=mvnrnd([0,0,0],[0.25,0,0.5;0,0.25,0.5;0.5,0.5,2],n); %RUNNING VARIABLE and ERROR TERMs
        u0=X(:,1);
        u1=X(:,2);
        x=X(:,3);
        V=randn(n,1)*sqrt(0.25);
        y1=(x>c)+1.25*x.*(x<=c)+u1;
        y0=0.5*x.*(x>c)+3*(x<=c)+u0-8;
        t=((y1-0.1*y0+(x>=0))>=4*V);
        y=y1.*t+y0.*(1-t);
        
    elseif (dgp==2)
        X=mvnrnd([0,0,0],[0.25,0,0.5;0,0.25,0.5;0.5,0.5,2],n);
        u0=X(:,1);
        u1=X(:,2);
        x=X(:,3);
        V=randn(n,1)*sqrt(0.25);
        y1=x+u1;
        y0=y1-u0-4;
        t=((y1-0.1*y0+2*V.*(x>=0))>=0);
        y=y1.*t+y0.*(1-t);
        
    elseif (dgp==3)
        x=norminv(normcdf(-2)+rand(n,1)*(normcdf(2)-normcdf(-2)),0,1);
        u=rand(n,1);
        v=(x<0).* max(0,(x+2).^2/8-0.01)+(x>=0).*min(1,(1-((x-2).^2)/8)+0.01);
        t=(v>u);
        y=(1-t.*(x<0)).*randn(n,1)+t.*(x<0).*(randn(n,1)-0.7);
        
    elseif (dgp==4)
        x=norminv(normcdf(-2)+rand(n,1)*(normcdf(2)-normcdf(-2)),0,1);
        u=rand(n,1);
        v=(x<0).* max(0,(x+2).^2/8-0.01)+(x>=0).*min(1,(1-((x-2).^2)/8)+0.01);
        t=(v>u);
        y=(1-t.*(x<0)).*randn(n,1)+t.*(x<0).*(1.675*randn(n,1));
        
    elseif (dgp==5)
        x=norminv(normcdf(-2)+rand(n,1)*(normcdf(2)-normcdf(-2)),0,1);
        u=rand(n,1);
        v=(x<0).* max(0,(x+2).^2/8-0.01)+(x>=0).*min(1,(1-((x-2).^2)/8)+0.01);
        t=(v>u);
        y=(1-t.*(x<0)).*randn(n,1)+t.*(x<0).*(0.515*randn(n,1));
        
    elseif (dgp==6)
        x=norminv(normcdf(-2)+rand(n,1)*(normcdf(2)-normcdf(-2)),0,1);
        u=rand(n,1);
        v=(x<0).* max(0,(x+2).^2/8-0.01)+(x>=0).*min(1,(1-((x-2).^2)/8)+0.01);
        t=(v>u);
        e=rand(n,1);
        yt_w=(e<=0.15).*(0.125*randn(n,1)-1)+(e>0.15).*(e<=0.35).*(0.125*randn(n,1)-0.5)...
            +(e>0.35).*(e<=0.65).*(0.125*randn(n,1))+(e>0.65).*(e<=0.85).*(0.125*randn(n,1)+0.5)...
            +(e>0.85).*(0.125*randn(n,1)+1);
        y=(1-t.*(x<0)).*randn(n,1)+t.*(x<0).*yt_w;
        
    end
    
end

% sdy=(y-mean(y))./std(y);
y=normcdf(y);

return