#! /usr/bin/Rscript

Sourcelocation <- "D:/Dropbox/Code and Data for FRD Test/simulation"
# Please change according to location of this file.
# Example: if this file is"D:/Dropbox/Code and Data for FRD Test/simulation/dpi_bandwidth.R"
#          then enter "D:/Dropbox/Code and Data for FRD Test/simulation"

packages = c("nprobust", "data.table");

for(package in packages){
  if(!require(package, character.only = TRUE)){
    install.packages(package, dependencies = TRUE);
    library(package, character.only = TRUE);
  };
  # Load the required packages. Installs each package if required.
};
# End loop over individual packages.
rm(package, packages);
# Clean up.
Filelocation <- paste0(Sourcelocation,"/simulationdataintoR.csv");
# Specify location of MATLAB CSV output containing simulation data.
Data <- unlist(fread(Filelocation));
names(Data) <- NULL;
# Reads the CSV file into R.
Cutoff <- Data[1L];
DM <- matrix(Data[-1L], ncol = 2L, byrow = FALSE);
# The cut-off is the first datapoint in the imported vector; the data is then arranged as Y and then X.
DF <- data.frame(y = DM[, 1L], x = DM[, 2L]);
# Put the data into a data frame.
rm(DM);
# Clean up.
h.left <- lpbwselect(y = DF$y, x = DF$x, eval = Cutoff, bwselect = "ce-dpi", subset = (DF$x < Cutoff));
h.right <- lpbwselect(y = DF$y, x = DF$x, eval = Cutoff, bwselect = "ce-dpi", subset = (DF$x >= Cutoff));
# Compute the bandwidth to the left and to the right of the cut-off.
h <- data.frame(c(h.left$bws[2L], h.right$bws[2L]));
# Store the h bandwidths in a vector (to the left and to the right resp.).
write.table(x = h, file = paste0(Sourcelocation, "/simulationdataoutofR.csv"), col.names = FALSE, row.names = FALSE);
# Save the bandwidths in a csv file.