function [Sn_hat,P_u]= step2(y,x,t,bw,c,nbs,vweight,rich)


n=length(y);
n_plus=sum((x>=c));
n_minus=sum((x<c));
an=(0.3*log(n))^(0.5);
bn=(0.4*log(n)/log(log(n)))^(0.5);

if length(bw)==1
    bw1=bw;%left of cutoff
    bw2=bw;%right of cutoff
    sn=sqrt(n*bw);
elseif length(bw)==2
    %Treating Input "bw" as Two-Sided Bandwidth'
    bw1=bw(1);%left of cutoff
    bw2=bw(2);%right of cutoff
    
    sn_num=(bw(1)*n_minus)*(bw(2)*n_plus);
    sn_denom=(bw(1)*n_minus)+(bw(2)*n_plus);
    sn=sqrt(sn_num/sn_denom);
else
    error('Bandwidth Input is Incorrect Size')
end

xi=sqrt(0.0001*(1-0.0001));

wtm=triawtC(x,bw1,c);               %Wni,- (vector from i=1 to n)
wtp=triawtT(x,bw2,c);               %Wni,+ (vector from i=1 to n)


wtm=wtm/sum(wtm);
wtp=wtp/sum(wtp);


bwx=2.34*sqrt(var(x))/(n)^(1/5);  % RoT bandwidth for estiamting f(x) at x=c.
fhat = sum(normpdf((x-c)./bwx))/n/bwx;


% n_bw = sum((x>-bw1).*(x<bw2));    % size of the sample which is within the bandwidth
% n_bw_plus=sum((x>=c).*(x<=bw2));  % size of the sample above the c and within the bandwidth.
% n_bw_minus=sum((x<c).*(x>-bw1));  % size of the sample below the c and within the bandwidth.
idx=find((x-c>-bw1).*(x-c<bw2));  % index of observations within bandwidth
y=y(idx);
t=t(idx);
wtm=wtm(idx);
wtp=wtp(idx);
clear idx



ncubetot=rich*(rich+1)/2;
nu_hat1=zeros(ncubetot,1);             %Store estimates of nu_1
nu_hat0=zeros(ncubetot,1);             %Store estimates of nu_0
% size(nu_hat1)
nu_sd_hat1=zeros(ncubetot,1);           % Store the standardize nu_hat1
nu_sd_hat0=zeros(ncubetot,1);           % Store the standardize nu_hat0
sigma_hat1=zeros(ncubetot,1);             %Store estimates of nu_1
sigma_hat0=zeros(ncubetot,1);             %Store estimates of nu_0


P_u=-100000000*ones(nbs,1);

u=randn(length(y),nbs); % row: sample size; column: number of bootstrapped samples

temp=0;
for r=1:rich
    ygrids=min(y):((max(y)-min(y))/(r)):max(y);
    ygrids=ygrids';
    catytemp=zeros(size(y,1),1);
    for i=1:(size(ygrids,1)-1)
        catytemp=catytemp+ i.*(y>=ygrids(i,1)).*(y<=ygrids(i+1,1));
    end
    for j=1:r
        temp=temp+1;
        mhatm1=sum(wtm.*(catytemp==j).*t);  % estimate of m_{1,m}(A), for interval A.
        mhatp1=sum(wtp.*(catytemp==j).*t);  % estimate of m_{1,p}(A)
        nu_hat1(temp,1)=mhatm1-mhatp1;  % estimate of nu_1(A)
        
        phi1=-sn*(wtp.*((catytemp==j).*t-mhatp1)-wtm.*((catytemp==j).*t-mhatm1)); % calculate the vector of phi_{v1,i}(A)
        
        if vweight==1
            sigma_hat1(temp)= sum((phi1).^2);
            sd1=max(xi,sqrt(sum((phi1).^2)));
        else
            sigma_hat1(temp)=1;
            sd1=1;
        end
        nu_sd_hat1(temp)=nu_hat1(temp,1)/sd1;
        
        psi_hat1=-bn*((sn.*nu_hat1(temp,1))<-an*sd1); % calculate the GMS, to move std to RHS to avoid divid zero
        
        
        
        P_u= max(P_u,(u'*phi1)/sd1+psi_hat1);
        
        
        mhatm0=sum(wtm.*(catytemp==j).*(1-t));
        mhatp0=sum(wtp.*(catytemp==j).*(1-t));
        nu_hat0(temp,1)=mhatp0-mhatm0;
        phi0=-sn*(wtm.*((catytemp==j).*(1-t)-mhatm0)-wtp.*((catytemp==j).*(1-t)-mhatp0));
        
        if vweight==1
            sigma_hat0(temp)= sum((phi0).^2);
            sd0=max(xi,sqrt(sum((phi0).^2)));
        else
            sigma_hat0(temp)=1;
            sd0=1;
        end
        nu_sd_hat0(temp)=nu_hat0(temp,1)/sd0;
        
        psi_hat0=-bn*((sn.*nu_hat0(temp,1))<-an*sd0);
        
        
        P_u= max(P_u,(u'*phi0)/sd0+psi_hat0);
    end
end

Sn_hat=sn*max(max(nu_sd_hat1),max(nu_sd_hat0));  % calculate the test statistics.



return