function wt=triawt(x,bw,c)

%--------------------------------------------------------------------
% PURPOSE: 
%--------------------------------------------------------------------   
% INPUTS:   x : running variable
%          bw : bandwidth
%           c : cutoff for treatment
%--------------------------------------------------------------------
% OUTPUT:  wt : numerator of kernel weights from Fan and Gibjels (1992)
%               for the uniform kernel 
%      
% NOTES: Adapted from R code from Hsu and Shen (2016)          
%
%--------------------------------------------------------------------
 kern=(1-abs((x-c)/bw)).*(abs(x-c)<bw);
 S1=sum(kern.*(x-c));
 S2=sum(kern.*(x-c).^2);
 wt=kern.*(S2-S1.*(x-c));

return